fl

{
ColorSensor S11059-02DT
     
 
PropForth 5.5
2013/11/17 19:57:42

 S11059-02DT      Propeller
     1 VDD   ----  3.3V
     5 GND   ----  GND
     6 SCL   ----  P28   
    10 SDA   ----  P29   

}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Slave addres h2A 
\ h2A 1 lshift 
h54 wconstant ColorSensor

\ register name
0 wconstant control
1 wconstant timing

h80 wconstant adc_res
h40 wconstant standby
8 wconstant Hi_gain
4 wconstant manual
3 wconstant 179.2msec
2 wconstant 22.4msec
1 wconstant 1.4msec
0 wconstant 87.5usec


\ =========================================================================== 
\  Word for I2C_device
\ =========================================================================== 
: err_msg ." I2C error" ;
\ If error, print message
\ ( n1 -- )   n1:t/f
: err? if err_msg cr then ;

\ Read data from register in i2c_device
\ ( n1 n2 -- n3 t/f )  n1:register  n2:slave_address  n3:data  t/f:true if there was an error
: i2c_rd
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
tuck _eewrite                 \ ( n2 n1 t/f )
\ Write register
swap _eewrite or              \ ( n2 t/f )
swap                          \ ( t/f n2 )
\ Start read_process
_eestart
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or _eewrite or              \ ( t/f )
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread             
\ Stop I2C
 _eestop                                         
 swap                         \ (n3 t/f )
;

\ Read sereis data from series register in i2c_device
\ ( n1 n2 n3 -- n4 . . nn t/f )  n1:number  n2:register  n3:slave_address  n4..nn:series data  t/f:true if there was an error
: i2c_rd_multi
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
tuck _eewrite                 \ ( n1 n3 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 n3 t/f )
swap                          \ ( n1 t/f n3 )
\ Start read_process
_eestart
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or _eewrite or              \ ( n1 t/f )
\ Read (n1-1)bytes
>r                            \ Push flag  ( n1 )
1- 0 do 0 _eeread loop        \ ( n4..nn-1 )
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread                    \ ( n4..nn )
r>                            \ Pop flag   ( n4..nn t/f )
\ Stop I2C
 _eestop                                         
;

\ Write data to register in i2c_device
\ ( n1 n2 n3 -- t/f )  n1:data  n2:register  n3:slave_address  t/f:true if there was an error
: i2c_wr
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
_eewrite                      \ ( n1 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 t/f )
\ Write data   
swap _eewrite or              \ ( t/f )   
\ Stop I2C
 _eestop 
;

\ Get color data
\ ( n1 n2 n3 -- n4 n5 n6 n7 t/f )  n1:delay time(msec) n2;control data  n3:slave address
\                                  n4:Red n5:Green n6:Blue n7:infrared t/f:true if there was an error 
: rd_ColorSensor
2dup                          \ ( n1 n2 n3 n2 n3 )
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
_eewrite >r                   \ ( n1 n2 n3 n2 )
\ Write control register
0 _eewrite r> or >r           \ ( n1 n2 n3 n2 )
\ Write data for control register
_eewrite r> or >r             \ ( n1 n2 n3 )
2dup                          \ ( n1 n2 n3 n2 n3 )
\ Start 
_eestart
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
_eewrite r> or >r             \ ( n1 n2 n3 n2 )
\ Write control register
0 _eewrite r> or >r           \ ( n1 n2 n3 n2 )
\ Write data(release reset) for control register
h7F and _eewrite r> or >r     \ ( n1 n2 n3 )
rot
delms                         \ Wait integration time  ( n2 n3 )
nip dup                       \ ( n3 n3 )
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
_eewrite r> or >r             \ ( n3 )
\ Write data register
3 _eewrite r> or >r           \ ( n3 )
                                                      
\ Start 
_eestart
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or _eewrite r> or >r         
7 0 do 0 _eeread loop                                                               
-1 _eeread                                                                       
\ Stop I2C
_eestop 
                                                
swap 8 lshift or >r         
swap 8 lshift or >r                                             
swap 8 lshift or >r
swap 8 lshift or              

r> r> r> r>                   \ ( n4 n5 n6 n7 t/f )                                        
;

\ =========================================================================== 
\  Main
\ =========================================================================== 

\ Display default setting
\ manual mode,Low gain,Tint=175usec,integration time= 546msec/ch
\ ( -- )
: test
hex
\
." control:"
control ColorSensor i2c_rd err? . cr
." manual timing:"
timing ColorSensor i2c_rd err?  
timing 1+ ColorSensor i2c_rd err? 
swap 8 lshift or . cr cr
decimal
;

\ Set N on manual timing register
\ ( n1 -- t/f )   n1:N  t/f:true if there was an error 
: Set_manual_timing
dup 
8 rshift timing ColorSensor i2c_wr           \ Write integration time manual setting register(MSB)
swap
hFF and timing 1+ ColorSensor i2c_wr        \ Write integration time manual setting register(LSB)
or
;

\ Mode:manual Gain:Low Tint:00(175usec) IntegralTime:546msec
: sample1
begin
     d2200 h84 ColorSensor rd_ColorSensor    
     err?
     ." Infrared:" . ." Blue:" . ." Green:" . ." Red:" .  cr
     fkey? swap drop
     d2200 delms
until
;

\ Mode:fixed Gain:High Tint:01(1.4msec) IntegralTime:1.4msec
: sample2
\ Set Mode:fixed Gain:High Tint:01(1.4msec) IntegralTime:1.4msec
6 h89 ColorSensor rd_ColorSensor    
err?
begin
     ." Infrared:" . ." Blue:" . ." Green:" . ." Red:" . cr
     6 delms
     \ Get 8 bytes
     8 3 ColorSensor i2c_rd_multi err?     
     swap 8 lshift or >r         
     swap 8 lshift or >r                                             
     swap 8 lshift or >r
     swap 8 lshift or              
     r> r> r>                                        
     fkey? swap drop
until
3drop drop
;


