fl

{
3-axis digital compass HMC5883L-module driver 
     
 
PropForth 5.5
2013/11/10 23:11:53

HMC5883L module      Propeller
       1 VDD    ----  3.3V
       2 VDDIO  ----  3.3V
       3 GND    ----  GND
       4 GND    ----  GND
       5 DRDY   ----  
       6 SDA    ----  P29   
       7 SCL    ----  P28   
       8 VDD    ----  3.3V

}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Slave addres for HMC5883L
h3C wconstant HMC5883L

\ register name
0 wconstant ConfigA
1 wconstant ConfigB
2 wconstant Mode
3 wconstant Data
9 wconstant Status
d10 wconstant RegA

0 wconstant Cont
1 wconstant Single
2 wconstant Idle

\ =========================================================================== 
\  Word for I2C_device
\ =========================================================================== 
: err_msg ." I2C error" ;
\ If error, print message
\ ( n1 -- )   n1:t/f
: err? if err_msg cr then ;

\ Read data from register in i2c_device
\ ( n1 n2 -- n3 t/f )  n1:register  n2:slave_address  n3:data  t/f:true if there was an error
: i2c_rd
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
tuck _eewrite                 \ ( n2 n1 t/f )
\ Write register
swap _eewrite or              \ ( n2 t/f )
swap                          \ ( t/f n2 )
\ Start read_process
_eestart
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or _eewrite or              \ ( t/f )
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread             
\ Stop I2C
 _eestop                                         
 swap                         \ (n3 t/f )
;

\ Write data to register in i2c_device
\ ( n1 n2 n3 -- t/f )  n1:data  n2:register  n3:slave_address  t/f:true if there was an error
: i2c_wr
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
_eewrite                      \ ( n1 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 t/f )
\ Write data   
swap _eewrite or              \ ( t/f )   
\ Stop I2C
 _eestop 
;

\ Read sereis data from series register in i2c_device
\ ( n1 n2 n3 -- n4 . . nn t/f )  n1:number  n2:register  n3:slave_address  n4..nn:series data  t/f:true if there was an error
: i2c_rd_multi
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
tuck _eewrite                 \ ( n1 n3 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 n3 t/f )
swap                          \ ( n1 t/f n3 )
\ Start read_process
_eestart
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or _eewrite or              \ ( n1 t/f )
\ Read (n1-1)bytes
>r                            \ Push flag  ( n1 )
1- 0 do 0 _eeread loop        \ ( n4..nn-1 )
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread                    \ ( n4..nn )
r>                            \ Pop flag   ( n4..nn t/f )
\ Stop I2C
 _eestop                                         
;


\ =========================================================================== 
\ Main
\ =========================================================================== 

\ Display all register's value 
: disp_reg
." Address  " ." value(hex)" cr
d13 0 do
     4 spaces
     i .                      \ Display register address
     9 emit 9 emit
     i HMC5883L i2c_rd err?   \ Read value
     hex .byte decimal        \ Display register value
     cr
loop
;

\ Communication test
\ Communication is ok when displayed "H43"
\ ( -- )
: comTest
RegA 3 0 do dup HMC5883L i2c_rd err? emit 1+ loop drop cr
;

\ Convert 2's complement form(16bit) to 32bit
\ None if positive
\ ( n1 -- n2 ) n1:2's complement form(16bit)  n2:32bit
: conv_32 dup hF000 and if hFFFF0000 or then ;

\
\
: conv_data
\ Data Y
swap 8 lshift or         
conv_32                  \ Convert to 32bit if minus
>r                       \ Push Y
\ Data Z
swap 8 lshift or                    
conv_32                  \ Convert to 32bit if minus   
\ Data X
rot2 swap 8 lshift or                   
conv_32                  \ Convert to 32bit if minus   
r>                       \ Pop Y
swap                     \ ( Z Y X )

;
     
\ Start continuous meauremaent
\ ( -- )      
: contMeasure
Cont Mode HMC5883L i2c_wr err?     \ Set continuous mode
begin
     \ Wait until ready
     begin
          Status HMC5883L i2c_rd err?
          1 and 
     until
     \ Read out 6bytes
     6 Data HMC5883L i2c_rd_multi err? 
     conv_data    
     ." X=" . ." Y=" . ." Z=" .
     cr
     fkey? swap drop
until
;

